#include "stdafx.h"

//#include <math.h>

#include "Geometry.h"
#include "Climax.h"
#include "FuncGrid3D.h"

void FuncGrid3D(float* Data,int ni,int nj,float nx1,float ny1,float nx2,float ny2,float rz)
{


	CClimax* ClimaxArray=new CClimax[ni*nj];
        int i,j;
        float rx=(nx2-nx1)/(float)ni;
	float ry=(ny2-ny1)/(float)nj;

	for(i=0;i<ni;i++)
        for(j=0;j<nj;j++)
	{
	 CVector m_Normal(1,1,1);
	 if(i>0&&i<ni-1&&j>0&&j<nj-1)
	 m_Normal=GetNormal(CVector(nx1+i*rx,ny1+j*ry,rz*Data[i*ni+j]),
	                    CVector(nx1+i*rx,ny1+(j-1)*ry,rz*Data[i*ni+j-1]),
			    CVector(nx1+(i+1)*rx,ny1+j*ry,rz*Data[(i+1)*ni+j]),
			    CVector(nx1+i*rx,ny1+(j+1)*ry,rz*Data[i*ni+j+1]),
			    CVector(nx1+(i-1)*rx,ny1+j*ry,rz*Data[(i-1)*ni+j])
						);

	 ClimaxArray[i*ni+j]=CClimax(CVector(nx1+i*rx,ny1+j*ry,rz*Data[i*ni+j]),m_Normal);

	}

	for(i=1;i<ni-2;i++)
        for(j=1;j<nj-2;j++)
	{
		glBegin(GL_POLYGON);
                 ClimaxArray[i*ni+j].Apply();
	         ClimaxArray[i*ni+j+1].Apply();
                 ClimaxArray[(i+1)*ni+j+1].Apply();
                 ClimaxArray[(i+1)*ni+j].Apply();
	        glEnd();

	}


//    for(i=0;i<ni*nj;i++)
//	 delete &ClimaxArray[i];
    delete ClimaxArray;

}