#include "stdafx.h"
#include "Material.h"
#include "JGLBase.h"

 CColor::CColor(float r,float g,float b,float a)
 {
	 V.R=r;V.G=g;V.B=b;V.A=a;
 }
 CMaterial::CMaterial()
 {
	 Default();
 }
 CMaterial::Default()
 {
	 m_Diffuse=CColor(1.0,0.0,1.0,1.0);
	 m_Ambient=CColor(0.0,0.0,0.0,1.0);
	 m_Specular=CColor(1.0,1.0,1.0,1.0);
	 m_Shininess=50.0;
 }
 CMaterial::Apply()
 {
	 glMaterialfv(GL_FRONT,GL_DIFFUSE,(float*)&(m_Diffuse.V));
	 glMaterialfv(GL_FRONT,GL_AMBIENT,(float*)&(m_Ambient.V));
	 glMaterialfv(GL_FRONT,GL_SPECULAR,(float*)&(m_Specular.V));
	 glMaterialfv(GL_FRONT,GL_SHININESS,(float*)&m_Shininess);
 }