// dteditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dtedit.h"
#include "dteditDlg.h"

#include <afxtempl.h> // for CArray

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDteditDlg dialog

CDteditDlg::CDteditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDteditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDteditDlg)
	m_strDocName = _T("");
	m_strFileNewName = _T("");
	m_strFilterExt = _T("");
	m_strFilterName = _T("");
	m_strRegId = _T("");
	m_strRegName = _T("");
	m_strWindowTitle = _T("");
	m_strTemplate = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDteditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDteditDlg)
	DDX_Text(pDX, IDC_EDIT_DOCUMENT_NAME, m_strDocName);
	DDX_Text(pDX, IDC_EDIT_FILE_NEW_NAME, m_strFileNewName);
	DDX_Text(pDX, IDC_EDIT_FILTER_EXTENSION, m_strFilterExt);
	DDX_Text(pDX, IDC_EDIT_FILTER_NAME, m_strFilterName);
	DDX_Text(pDX, IDC_EDIT_REGISTRATION_ID, m_strRegId);
	DDX_Text(pDX, IDC_EDIT_REGISTRATION_NAME, m_strRegName);
	DDX_Text(pDX, IDC_EDIT_WINDOW_TITLE, m_strWindowTitle);
	DDX_Text(pDX, IDC_EDIT_TEMPLATE, m_strTemplate);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDteditDlg, CDialog)
	//{{AFX_MSG_MAP(CDteditDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_EXAMPLE, OnBtnExample)
	ON_BN_CLICKED(IDC_BTN_BUILD, OnBtnBuild)
	ON_BN_CLICKED(IDC_BTN_PARSE, OnBtnParse)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDteditDlg message handlers

BOOL CDteditDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDteditDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDteditDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDteditDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDteditDlg::OnBtnExample() 
{
	m_strDocName = "Sheet1";
	m_strFileNewName = "Worksheet";
	m_strFilterExt = ".xls";
	m_strFilterName = "Worksheets (*.xls)";
	m_strRegId = "ExcelWorksheet";
	m_strRegName = "Microsoft Excel Worksheet";
	m_strWindowTitle = "Microsoft Excel";

	UpdateData(false);

	OnBtnBuild();
}

void CDteditDlg::OnBtnBuild() 
{
	UpdateData();

	m_strTemplate.Format("%s\\n%s\\n%s\\n%s\\n%s\\n%s\\n%s", 
		m_strWindowTitle,
		m_strDocName,
		m_strFileNewName,
		m_strFilterName,
		m_strFilterExt,
		m_strRegId,
		m_strRegName);

	UpdateData(false);
}

void CDteditDlg::OnBtnParse() 
{
	UpdateData();

	CArray<CString*, CString*> oFields;

	oFields.Add(&m_strWindowTitle);
	oFields.Add(&m_strDocName);
	oFields.Add(&m_strFileNewName);
	oFields.Add(&m_strFilterName);
	oFields.Add(&m_strFilterExt);
	oFields.Add(&m_strRegId);
	oFields.Add(&m_strRegName);

	CString strTemp(m_strTemplate);
	strTemp += "\\n";
	int nLoc;
	for(int i=0, j=oFields.GetSize(); i<j; i++)
	{
		nLoc = strTemp.Find("\\n");
		*oFields[i] = strTemp.Left(nLoc);
		CString strT = strTemp.Right(strTemp.GetLength() - nLoc - 2);
		strTemp = strT;
	}
	UpdateData(false);	
}

void CDteditDlg::OnCancel() 
{
// Don't let ESC key close dialog	
//	CDialog::OnCancel();
}

void CDteditDlg::OnClose() 
{
// Since CDteditDlg::OnCancel was subverted, call it here for cleanup!
	CDialog::OnCancel();
	
	CDialog::OnClose();
}
