#include "stdafx.h"
#include "Arrow.h"
#include "JGLBase.h"
#include <math.h>



Arrow(CVector start,CVector end)
{
	CVector m_Z(0,0,1);                          
	CVector m_Direction=end-start;               
	float   Length=m_Direction.GetMagnitude();   
	CVector m_V=m_Z.x(m_Direction);             
    float   Cos_Theta=m_Z*m_Direction/Length;    
	float   Theta=acos(Cos_Theta)*180/3.1415926; 
	glPushMatrix();
	  glTranslatef(start.V.x,start.V.y,start.V.z); 
	  glRotatef(Theta,m_V.V.x,m_V.V.y,m_V.V.z);    
          //******
	  glPushMatrix();                              
	    glTranslatef(0,0,Length-0.3);              
	    auxSolidCone(0.05,0.3);                   
	    glTranslatef(0,0,-1);                      
        glRotatef(90,1,0,0);                       
	    auxSolidCylinder(0.02,Length-0.3);         
	  glPopMatrix();
	  //*********************
	glPopMatrix();

}