#include "stdafx.h"
#include "JGLBase.h"
#include "Vector.h"
#include <math.h>
#include "Geometry.h"

#define PI  3.1415926
#define STEP 0.1

void JFillEllipse(CVector center,float a,float b,int plane)
{
	for(float theta=0;theta<2*PI;theta+=STEP)
	{
	 glBegin(GL_POLYGON);
	 if(plane==XY)
	 {glVertex3f(center.V.x+a*cos(theta),center.V.y+b*sin(theta),center.V.z);
	  glVertex3f(center.V.x+a*cos(theta+STEP),center.V.y+b*sin(theta+STEP),center.V.z);
	 }
	 else if(plane==YZ)
	 {glVertex3f(center.V.x,center.V.y+a*sin(theta),center.V.z+b*cos(theta));
	  glVertex3f(center.V.x,center.V.y+a*sin(theta+STEP),center.V.z+b*cos(theta+STEP));
	 }
         else     //XZ
	 {glVertex3f(center.V.x+a*cos(theta),center.V.y,center.V.z+b*sin(theta));
	  glVertex3f(center.V.x+a*cos(theta+STEP),center.V.y,center.V.z+b*sin(theta+STEP));
	 }
          glVertex3f(center.V.x,center.V.y,center.V.z);
	  glEnd();
	}

}
 
void JCircleXY(CVector center,float radiu)
{
	for(float theta=0;theta<2*PI;theta+=STEP)
	{
	 glBegin(GL_LINES);
	 glVertex3f(center.V.x+radiu*cos(theta),center.V.y+radiu*sin(theta),center.V.z);
	 glVertex3f(center.V.x+radiu*cos(theta+STEP),center.V.y+radiu*sin(theta+STEP),center.V.z);
	 glEnd();
	}
}

void JLine(float x1,float y1,float z1,float x2,float y2,float z2)
{
    glBegin(GL_LINES);
    glVertex3f(x1,y1,z1);
    glVertex3f(x2,y2,z2);
    glEnd();
}
void JLine(CVector V1,CVector V2)
{JLine(V1.V.x,V1.V.y,V1.V.z,V2.V.x,V2.V.y,V2.V.z);
}