
#ifndef POLARIZELIGHT_H
#define POLARIZELIGHT_H
#include "Vector.h"

class CPolarizeLightXZ
{public:
          float  m_Angle;          
	  CVector m_Direction;     
	  CVector m_Start,m_End;   
	  float m_Length;          
	  float m_Theta;           
	  float m_WaveLen;         
	  float m_A1,m_A2;         
          int   m_LoopCount;       
	  float m_AnimatePhase;    
	  CPolarizeLightXZ(CVector start,float direction,float length,float wavelen,float theta,float a1=1,float a2=1,float loop=80);
          CPolarizeLightXZ(CVector start,CVector end,float wavelen,float theta,float a1=1,float a2=1,float loop=80);
          SetPhase(float theta);
	  SetA1(float a1){m_A1=a1;};
	  SetA2(float a2){m_A2=a2;};
          Display();
};
#endif

