//---------------------------------------------------------------------------
#ifndef Vector_H
#define Vector_H
//Declare the CVector class.
struct Coordinate
{
   float x,y,z;

};

class CVector
{public:

   CVector(Coordinate&);
   CVector(float=0,float=0,float=0);

   Coordinate V;                     
   void Normalize();                 
   float GetMagnitude();             
   CVector operator +(CVector&);
   CVector operator -(CVector&);
   float   operator *(CVector&);     
   CVector  x(CVector&);             
   void operator +=(CVector&);
   void operator -=(CVector&);
   CVector operator *(float a);      

};

CVector GetNormal(CVector&,CVector&,CVector&,CVector&,CVector&);


//---------------------------------------------------------------------------
#endif
